## minexpert2 7.2.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.12)

############################################################
############################################################
# Basic information about project

project(mineXpert2
  DESCRIPTION "A program to visualize and mine mass spectrometric data"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")

set(VERSION 7.2.0)

# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2020 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX AND NOT APPLE)
  # Run the following cmake command line:
  # cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development

  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(APPLE)
  # Run the following cmake command line:
  # cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=0 ../../development

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# QCustomPlot

if(NOT QCustomPlot_FOUND)
  message("Still searching for QCustomPlot")
  set(QCustomPlot_DIR ${CMAKE_MODULE_PATH})
  find_package(QCustomPlot REQUIRED)
  add_definitions(-DQCUSTOMPLOT_USE_LIBRARY)
endif()


# OPENMP
message(STATUS "${BoldYellow}OpenMP support is compulsory.${ColourReset}")
if(NOT OpenMP_FOUND)
  include(FindOpenMP)
  if(OpenMP_FOUND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  else()
    message(STATUS "ERROR: OpenMP could not be found.")
  endif()
endif()


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")


# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
  execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/splashscreen.svg
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${CMAKE_PROJECT_NAME}")
add_subdirectory(doc)


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
####################
# BUILD OF THE TESTS
if(TESTS)
  add_subdirectory(tests)
endif()


#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
message("")

message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring src/ for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)


########################################################
# Files
set(${TARGET}_nongui_SRCS
  #
  # Some globals.
  nongui/globals.cpp
  #
  # The classes for the IsoSpec calculations.
  nongui/Atom.cpp
  nongui/AtomCount.cpp
  nongui/Formula.cpp
  nongui/IsoSpecEntity.cpp
  nongui/Isotope.cpp
  nongui/Ponderable.cpp
  #
  # The main class that hold the mass data.
  nongui/MsRunDataSet.cpp
  #
  # The class to handle the statistics computation about a given MsRunDataSet.
  nongui/MsRunDataSetStats.cpp

  nongui/MassSpecDataFileLoader.cpp
  #
  # The classe that monitors integrators.
  nongui/MassDataIntegratorTask.cpp
  #
  # The base class of the integrators.
  nongui/MassDataIntegrator.cpp
  #
  # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
  nongui/MsRunDataSetTreeMassDataIntegratorToRt.cpp
  nongui/MsRunDataSetTreeMassDataIntegratorToMz.cpp
  nongui/MsRunDataSetTreeMassDataIntegratorToDt.cpp
  nongui/MsRunDataSetTreeMassDataIntegratorToDtRtMz.cpp
  nongui/MsRunDataSetTreeMassDataIntegratorToTicInt.cpp
  #
  # The various MsRunDataSetTreeNodeVisitor classes.
  nongui/BaseMsRunDataSetTreeNodeVisitor.cpp
  nongui/MsRunStatisticsTreeNodeVisitor.cpp
  nongui/TicChromTreeNodeCombinerVisitor.cpp
  nongui/IntensityTreeNodeCombinerVisitor.cpp
  nongui/RtDtMzColorMapsTreeNodeCombinerVisitor.cpp
  nongui/RtDtColorMapTreeNodeCombinerVisitor.cpp
  nongui/TraceTreeNodeCombinerVisitor.cpp
  nongui/MassSpectrumTreeNodeCombinerVisitor.cpp
  nongui/DriftSpectrumTreeNodeCombinerVisitor.cpp
  nongui/MultiTreeNodeCombinerVisitor.cpp
  #
  # The various integrators that use QualifiedMassSpectrumVector.
  nongui/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
  #
  # The classes that handle the processing flow
  nongui/ProcessingFlow.cpp
  nongui/ProcessingStep.cpp
  nongui/ProcessingSpec.cpp
  nongui/ProcessingType.cpp
  #
  # The classes that handle the parameters for the various integrations and the
  # display of traces.
  nongui/MzIntegrationParams.cpp
  nongui/MsFragmentationSpec.cpp
  #
  # Peak-shaping classes (Gaussian Lorentzian peak shapes).
  nongui/MassPeakShaperConfig.cpp
  nongui/MassPeakShaper.cpp
  #
  # Analysis preferences
  nongui/AnalysisPreferences.cpp
  )

set(${TARGET}_gui_SRCS
  main.cpp
  gui/Application.cpp
  gui/ProgramWindow.cpp
  gui/MsRunSelectorDlg.cpp
  gui/AboutDlg.cpp
  #
  gui/ConsoleWnd.cpp
  #
  gui/MsRunReadTask.cpp
  #
  gui/OpenMsRunDataSetsDlg.cpp
  gui/ColorSelector.cpp
  #
  gui/TaskMonitorCompositeWidget.cpp
  gui/TaskMonitorWnd.cpp
  #
  # The ms run data set tree view classes
  gui/MsRunDataSetTableViewWnd.cpp
  gui/MsRunDataSetTableViewItem.cpp
  gui/MsRunDataSetTableView.cpp
  gui/MsRunDataSetTableViewModel.cpp
  gui/MsRunDataSetTableViewProxyModel.cpp
  #	
  # The MS fragmentation specification dialog
  gui/MsFragmentationSpecDlg.cpp
  gui/MzIntegrationParamsDlg.cpp
  #
  # The data plot graph/widget tree classes
  gui/DataPlottableNode.cpp
  gui/DataPlottableTree.cpp
  #
  # The trace plot widgets derived from pappso::BaseTracePlotWidget
  gui/TicXicChromTracePlotWidget.cpp
  gui/MassSpecTracePlotWidget.cpp
  gui/DriftSpecTracePlotWidget.cpp
  #
  # The trace plot composite widgets
  gui/BasePlotCompositeWidget.cpp
  gui/BaseTracePlotCompositeWidget.cpp
  gui/TicXicChromTracePlotCompositeWidget.cpp
  gui/MassSpecTracePlotCompositeWidget.cpp
  gui/DriftSpecTracePlotCompositeWidget.cpp
  #
  # The color map plot composite widgets
  gui/BaseColorMapPlotCompositeWidget.cpp
  gui/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
  gui/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
  gui/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
  #
  # The plot windows
  gui/BasePlotWnd.cpp
  #	
  # Trace plot windows
  gui/BaseTracePlotWnd.cpp
  gui/BaseColorMapPlotWnd.cpp
  gui/TicXicChromTracePlotWnd.cpp
  gui/MassSpecTracePlotWnd.cpp
  gui/DriftSpecTracePlotWnd.cpp
  #
  # Color map plot windows
  gui/TicXicChromMassSpecColorMapWnd.cpp
  gui/TicXicChromDriftSpecColorMapWnd.cpp
  gui/DriftSpecMassSpecColorMapWnd.cpp
  #
  # The save plot to graphics file
  gui/SaveToGraphicsFileDlg.cpp
  #
  # The IsoSpec computations-related widgets
  gui/IsoSpecDlg.cpp
  gui/IsoSpecTableView.cpp
  gui/IsoSpecTableViewModel.cpp
  gui/MassPeakShaperDlg.cpp
  #
  # The ProcessingFlow viewer dialog window
  gui/ProcessingFlowViewerDlg.cpp
  #
  # The XIC chromatogram feature
  gui/XicExtractionWnd.cpp
  #
  # Analysis preferences
  gui/AnalysisPreferencesDlg.cpp
  )

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/MsRunSelectorDlg.ui
  gui/ui/OpenMsRunDataSetsDlg.ui
  gui/ui/MsRunDataSetTableViewWnd.ui
  gui/ui/BasePlotWnd.ui
  gui/ui/BasePlotCompositeWidget.ui
  gui/ui/TaskMonitorCompositeWidget.ui
  gui/ui/TaskMonitorWnd.ui
  gui/ui/ConsoleWnd.ui
  gui/ui/MsFragmentationSpecDlg.ui
  gui/ui/MzIntegrationParamsDlg.ui
  gui/ui/SaveToGraphicsFileDlg.ui
  gui/ui/IsoSpecDlg.ui
  gui/ui/MassPeakShaperDlg.ui	
  gui/ui/ElementGroupBoxWidget.ui
  gui/ui/ProcessingFlowViewerDlg.ui
  gui/ui/XicExtractionWnd.ui
  gui/ui/AnalysisPreferencesDlg.ui)


find_package(Qt5 COMPONENTS Widgets Xml Svg PrintSupport REQUIRED)

qt5_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt5_add_resources(${TARGET}_QRC_CPP ../minexpert2.qrc)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
# NOT sure about this. Let's comment that for the moment.
# set_source_files_properties(${${TARGET}_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
# set_source_files_properties(${${TARGET}_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)

include_directories(

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # For all the source subdirectories
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}

  ${Qt5Widgets_INCLUDE_DIRS}
  ${Qt5Xml_INCLUDE_DIRS}
  ${Qt5Svg_INCLUDE_DIRS}
  ${Qt5Sql_INCLUDE_DIRS}
  ${Qt5PrintSupport_INCLUDE_DIRS}
  ${IsoSpec++_INCLUDE_DIRS}
  )


###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET} WIN32
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    )

elseif(UNIX AND NOT APPLE)

  add_executable(${TARGET}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    )

elseif(APPLE)

  add_executable(${TARGET} MACOSX_BUNDLE
    ${${TARGET}-exec_SRCS}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
    ../images/icons/${TARGET}.icns
    )

  set_target_properties(${TARGET} PROPERTIES 
    MACOSX_BUNDLE_ICON_FILE ${TARGET}.icns)

  # We need to specify that manually because FindOpenMP() does 
  # not work on macports as of 20200727.
  target_include_directories(${TARGET}
    PUBLIC ${OpenMP_INCLUDE_DIRS})
  target_link_libraries(${TARGET}
    OpenMP::OpenMP)

endif()


# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
  Qt5::Widgets
  Qt5::Xml
  Qt5::Svg
  Qt5::PrintSupport
  QCustomPlot::QCustomPlot
  IsoSpec++::IsoSpec++
  PappsoMSpp::Core
  PappsoMSpp::Widget
  )


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})

message(STATUS "Now printing all the include directories -I...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "included dir='${dir}'")
endforeach()

message(STATUS "Now printing all the linking directories -L...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY LINK_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "link directory dir='${dir}'")
endforeach()

if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
  # We want to install the binary arch-dependent target in
  # specific situations. To have proper control, we define the arch
  # component.
  install(TARGETS ${TARGET}
    RUNTIME
    COMPONENT arch
    DESTINATION ${BIN_DIR})
endif()


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== tests/CMakeLists.txt ===
if(TESTS AND (UNIX AND NOT APPLE))

  message(\n${BoldRed}"Now configuring src/tests for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)
  message("TARGET is: ${TARGET}")

  message("non gui files: ${${TARGET}_nongui_SRCS}")

  ########################################################
  # Files

  file(GLOB tests_SRCS

    # Files from the main code source tree
    ../src/nongui/MzIntegrationParams.cpp

    # The main() of the tests executable file
    testmain.cpp

    # Files for the tests
    nongui/DataPoint_test.cpp
    nongui/Trace_test.cpp
    nongui/MapTrace_test.cpp
    nongui/MassSpectrum_test.cpp
    nongui/TraceCombiner_test.cpp
    nongui/MassSpectrumCombiner_test.cpp
    nongui/MzIntegrationParams_test.cpp
    )

  find_package(Catch2 REQUIRED)


  # Instruct CMake to run moc automatically when needed.
  set(CMAKE_AUTOMOC ON)

  find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

  qt5_wrap_ui(tests_UIS_H ${${TARGET}_UIS})

  qt5_add_resources(tests_QRC_CPP ../minexpert2.qrc)

  add_executable(tests
    ${tests_SRCS}
    ${tests_UIS_H}
    ${tests_QRC_CPP})

  target_compile_definitions(tests PRIVATE TESTS) #add -DTESTS
  set_property(TARGET tests PROPERTY CXX_STANDARD 17) # we want C++17

  qt5_use_modules(tests Widgets)
  qt5_use_modules(tests Xml)
  qt5_use_modules(tests Svg)
  qt5_use_modules(tests Sql)
  qt5_use_modules(tests Script)
  qt5_use_modules(tests PrintSupport)

  #message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")

  include_directories(
    ${CMAKE_SOURCE_DIR}

    ${CMAKE_SOURCE_DIR}/src/nongui
    ${CMAKE_SOURCE_DIR}/src/gui

    ${CMAKE_CURRENT_SOURCE_DIR}

    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5Xml_INCLUDE_DIRS}
    ${Qt5Svg_INCLUDE_DIRS}
    ${Qt5Sql_INCLUDE_DIRS}
    ${Qt5PrintSupport_INCLUDE_DIRS}
    )

  target_include_directories(tests PRIVATE
    ${INCLUDE_DIRECTORIES}
    )

  set(required_target_link_libraries
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::PrintSupport
    QCustomPlot::QCustomPlot
    IsoSpec++::IsoSpec++
    PappsoMSpp::Core
    PappsoMSpp::Widget
    Catch2::Catch2
    )

  target_link_libraries(tests
    ${required_target_link_libraries})

  message("")
  message(STATUS "${BoldGreen}Finished processing src/tests.${ColourReset}")
  message("")

else()
  message(STATUS "Tests are not built.")
endif()

=== debian/changelog ===
minexpert2 (7.2.0-1) unstable; urgency=low

  * New feature to remove all the empty composite plot widgets in one go.

  * Improvements in the user experience (intuitive menu item ordering).

  * General overview of the shortcuts to all the commands.

  * Add the CC-4 license to d/copyright, thanks to Thorsten Alteholz
    <debian@alteholz.de> for spotting the files concerned.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Oct 2020 09:08:23 +0200

minexpert2 (7.1.0-1) unstable; urgency=low

  *  New version fixing bugs with integration to MZ when starting from a XIC
     chromatogram obtained using the XIC computation dialog window.

  *  Minor update to the user manual revision history.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Oct 2020 19:17:17 +0200

minexpert2 (7.0.1-1) unstable; urgency=low

  * Fix bug with ms level not recorded in the ProcessingFlow when integrating
    from the ms run data set table view.

  * Implement plus/minus combinations right into the combined plot widget.

  * Update the user manual according to the improvements above.

  * Remove unused xslt formatter stuff for xep.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 01 Oct 2020 13:47:24 +0200

minexpert2 (7.0.0-1) unstable; urgency=low

  * First release of the MSn support.

  * Update of the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Sep 2020 17:40:56 +0200

minexpert2 (6.0.4-1) unstable; urgency=low

  * Add CMake-based support for Catch2.

  * Implemented a bunch of new tests.

  * Big fixes in the MS^n support code.

  * Fixes in d/copyright (was rejected by FTPMaster). Thanks to FTPMaster
    Thorsten Alteholz <ftpmaster@ftp-master.debian.org>.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 15 Sep 2020 10:21:59 +0200

minexpert2 (6.0.3-1) unstable; urgency=low

  * Fix small bug with integration to RT from one color map type.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 28 Jul 2020 20:10:49 +0200

minexpert2 (6.0.2-1) UNRELEASED; urgency=low

  * Fixes to the mechanism that sets the user manual version number.  Now the
    user manual is easily accessed right from the AboutDlg dialog window.

  * Other fixes to the CMake build system, in particular the fact
    that the correct user manual version is accessed from the website.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 24 Jul 2020 14:28:53 +0200

minexpert2 (6.0.1-1) unstable; urgency=low

  * mineXpert2 is both a full rewrite of the previous mineXpert component of
    the msXpertSuite software package (that includes massXpert and mineXpert)
    and now corresponds to a separate package that will be shipped apart 
    from the massXpert package. 

  * The version number starts at 6.0.1.

  * I have conserved the package history below just for the record.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 22 Jul 2020 20:03:49 +0200

minexpert2 (6.0.0-1) UNRELEASED; urgency=low

  * mineXpert2 is both a full rewrite of the previous mineXpert component of
    the msXpertSuite software package (that includes massXpert and mineXpert)
    and now corresponds to a separate package that will be shipped apart 
    from the massXpert package. 

  * The version number starts at 6.0.0.

  * I have conserved the package history below just for the record.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 22 Jul 2020 19:12:56 +0200

msxpertsuite (5.8.7-1) UNRELEASED; urgency=low

  * Fixes to the icons handling.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 13 Mar 2019 14:47:15 +0100

msxpertsuite (5.8.6-2) unstable; urgency=low

  * d/control: +Homepage: http://www.msxpertsuite.org/ (not https).

  * Fix the license mismatch output by lintian (appstream.xml file vs
    d/copyright).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 12:40:54 +0100

msxpertsuite (5.8.6-1) unstable; urgency=low

  * Reinstate partially all the conflicts/breaks/replaces statements for the
    mspxertsuite-massxpert binary package. This ensures that upgrade of
    massxpert from stable's version to this version does not stumble upon
    overwriting blocks. Thanks to Andreas Beckmann
    <anbe@debian.org> for reporting the piuparts log (Closes: #922287).

  * Took advantage to update the
    minexpert/org.msxpertsuite.minexpert.appdata.xml file (which justifies new
    upstream version.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 14 Feb 2019 17:08:52 +0100

msxpertsuite (5.8.5-1) unstable; urgency=low

  * appdata fixes to the gpl version number (lintian warning).

  * d/rules: fix problem with the path to the .fop.xconf file not being found.
    This is a missing fix with respect to the other d/rules files that was
    working.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 12 Feb 2019 08:59:24 +0100

msxpertsuite (5.8.4-1) unstable; urgency=low

  * Make the user manuals and install them under the control of CMake.

  * Convert d/rules to the debhelper mini format.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 11 Feb 2019 13:46:36 +0100

msxpertsuite (5.8.3-1) unstable; urgency=low

  * Make sure CMake is called during dpkg-buildpackage -A (Closes: #921727).
    Thanks to Santiago Vila <sanvila@debian.org> for the report.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 08 Feb 2019 17:02:20 +0100

msxpertsuite (5.8.2-1) unstable; urgency=low

  * New version with the daps dependency for the user manuals build.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Feb 2019 19:04:58 +0100

msxpertsuite (5.8.1-1) UNRELEASED; urgency=low

  * New upstream release with new configuration mode for the IsoSpec isotopic
    cluster calculations.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 04 Feb 2019 21:33:53 +0100

msxpertsuite (5.8.0-1) UNRELEASED; urgency=low

  * New upstream version with implementation of a GUI for the IsoSpec library.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 29 Jan 2019 10:12:55 +0100

msxpertsuite (5.7.3-1) unstable; urgency=low

  * Fixes upstream.



=== debian/control ===
Source: minexpert2
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.18.25),
 graphicsmagick-imagemagick-compat,
 libgomp1,
 qtbase5-dev (>= 5.11.3),
 libqt5svg5-dev (>= 5.11.3),
 cmake (>= 3.12),
 daps (>= 3.0.0),
 libjeuclid-core-java,
 libjeuclid-fop-java,
 docbook-mathml,
 libjs-jquery,
 libjs-highlight.js,
 libjs-mathjax,
 fonts-mathjax,
 fonts-mathjax-extras,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 libqcustomplot-dev(>= 2.0),
 libisospec++-dev (>=2.1.2),
 libpappsomspp-dev (>= 0.8.2),
 libpappsomspp-widget-dev (>= 0.8.2),
 docbook-to-man,
 qttools5-dev-tools,
 qtchooser
Standards-Version: 4.5.0
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git


Package: minexpert2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: minexpert2-doc (>= ${source:Upstream-Version})
Replaces: msxpertsuite-minexpert (<< 6.0.0)
Breaks: msxpertsuite-minexpert (<< 6.0.0)
Conflicts: msxpertsuite-minexpert
Description: MS^n mass spectrometric data visualization and mining (runtime)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the mineXpert2 program.


Package: minexpert2-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: msxpertsuite-minexpert-data-doc (<< 6.0.0)
Breaks: msxpertsuite-minexpert-data-doc (<< 6.0.0)
Conflicts: msxpertsuite-minexpert-data-doc
Description: MS^n mass spectrometric data visualization and mining (doc)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.

## minexpert2 7.3.0

=== debian/changelog ===
minexpert2 (7.3.0-1) unstable; urgency=low

  * Closes: #973232 (I was waiting for libpappsomspp 0.8.8 to be in testing).

  * New feature to rescale the intensities of color maps to log10 so that
    invisible feature appear.

  * Updated the documentation to document the new feature.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 23 Oct 2020 13:37:46 +0200

=== debian/control ===
--- 
+++ 
@@ -23,8 +23,8 @@
  fonts-ebgaramond-extra,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.2),
- libpappsomspp-dev (>= 0.8.2),
- libpappsomspp-widget-dev (>= 0.8.2),
+ libpappsomspp-dev (>= 0.8.8),
+ libpappsomspp-widget-dev (>= 0.8.8),
  docbook-to-man,
  qttools5-dev-tools,
  qtchooser

## minexpert2 7.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,10 @@
 # Basic information about project
 
 project(mineXpert2
-  DESCRIPTION "A program to visualize and mine mass spectrometric data"
+  DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 7.2.0)
+set(VERSION 7.4.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -236,8 +236,17 @@
 #############################################################
 ####################
 # BUILD OF THE TESTS
-if(TESTS)
+if(MAKE_TESTS)
+  #MESSAGE("MAKE_TEST was set to ${MAKE_TEST}")
+  enable_testing()
+  include(CTest)
+
+  if(BUILD_TESTING)
+
   add_subdirectory(tests)
+
+  endif(BUILD_TESTING)
+
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,6 @@
   #
   # The classes that handle the parameters for the various integrations and the
   # display of traces.
-  nongui/MzIntegrationParams.cpp
   nongui/MsFragmentationSpec.cpp
   #
   # Peak-shaping classes (Gaussian Lorentzian peak shapes).

=== debian/changelog ===
minexpert2 (7.4.0-1) unstable; urgency=low

  * New upstream version implementing features as a response to the article's
    reviewers' remarks.

  * Fix to the *.desktop file (localized Categories).

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 19 Dec 2020 08:20:02 +0100

=== debian/control ===
--- 
+++ 
@@ -23,8 +23,8 @@
  fonts-ebgaramond-extra,
  libqcustomplot-dev(>= 2.0),
  libisospec++-dev (>=2.1.2),
- libpappsomspp-dev (>= 0.8.8),
- libpappsomspp-widget-dev (>= 0.8.8),
+ libpappsomspp-dev (>= 0.8.15),
+ libpappsomspp-widget-dev (>= 0.8.15),
  docbook-to-man,
  qttools5-dev-tools,
  qtchooser
@@ -37,7 +37,7 @@
 Package: minexpert2
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+ ${misc:Depends}
 Suggests: minexpert2-doc (>= ${source:Upstream-Version})
 Replaces: msxpertsuite-minexpert (<< 6.0.0)
 Breaks: msxpertsuite-minexpert (<< 6.0.0)

## minexpert2 7.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   DESCRIPTION "A program to visualize and explore mass spectrometric data"
   HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")
 
-set(VERSION 7.4.0)
+set(VERSION 7.4.1)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-if(TESTS AND (UNIX AND NOT APPLE))
+if(MAKE_TESTS AND (UNIX AND NOT APPLE))
 
   message(\n${BoldRed}"Now configuring src/tests for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)
   message("TARGET is: ${TARGET}")
@@ -8,22 +8,12 @@
   ########################################################
   # Files
 
-  file(GLOB tests_SRCS
-
-    # Files from the main code source tree
-    ../src/nongui/MzIntegrationParams.cpp
+  set(tests_SRCS
 
     # The main() of the tests executable file
     testmain.cpp
 
     # Files for the tests
-    nongui/DataPoint_test.cpp
-    nongui/Trace_test.cpp
-    nongui/MapTrace_test.cpp
-    nongui/MassSpectrum_test.cpp
-    nongui/TraceCombiner_test.cpp
-    nongui/MassSpectrumCombiner_test.cpp
-    nongui/MzIntegrationParams_test.cpp
     )
 
   find_package(Catch2 REQUIRED)
@@ -32,7 +22,7 @@
   # Instruct CMake to run moc automatically when needed.
   set(CMAKE_AUTOMOC ON)
 
-  find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)
+  find_package(Qt5 COMPONENTS Widgets Xml Svg)
 
   qt5_wrap_ui(tests_UIS_H ${${TARGET}_UIS})
 
@@ -49,8 +39,6 @@
   qt5_use_modules(tests Widgets)
   qt5_use_modules(tests Xml)
   qt5_use_modules(tests Svg)
-  qt5_use_modules(tests Sql)
-  qt5_use_modules(tests Script)
   qt5_use_modules(tests PrintSupport)
 
   #message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")
@@ -66,7 +54,6 @@
     ${Qt5Widgets_INCLUDE_DIRS}
     ${Qt5Xml_INCLUDE_DIRS}
     ${Qt5Svg_INCLUDE_DIRS}
-    ${Qt5Sql_INCLUDE_DIRS}
     ${Qt5PrintSupport_INCLUDE_DIRS}
     )
 
@@ -89,6 +76,9 @@
   target_link_libraries(tests
     ${required_target_link_libraries})
 
+  #add_test(tests "All Catch2-based tests")
+  add_test(tests "tests")
+
   message("")
   message(STATUS "${BoldGreen}Finished processing src/tests.${ColourReset}")
   message("")
@@ -97,3 +87,4 @@
   message(STATUS "Tests are not built.")
 endif()
 
+

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  message("")
  message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
  message("")

  # The version of the program needs to be set in the user manual front
  # matter.
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

  # Command:
  # make minexpert-doc
  # Makes use of the local  Makefile file.
  # Will generate HTML and PDF documentation in the build directory
  add_custom_target(${TARGET_LOWERCASE}-doc ALL
    COMMAND make all
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "DocBook-based user manual documentation for ${CMAKE_PROJECT_NAME}")

  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/build/minexpert2-user-manual/${TARGET_LOWERCASE}-doc.pdf
    DESTINATION ${DOC_DIR})

  install(DIRECTORY 
    ${CMAKE_CURRENT_SOURCE_DIR}/build/${TARGET_LOWERCASE}-user-manual/html/${TARGET_LOWERCASE}-user-manual/
    DESTINATION ${DOC_DIR}/html)

  message("")
  message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
  message("")

else()

  message(STATUS "User manual build skipped")

endif()

=== doc/user-manual/Makefile ===
project=minexpert2

topDir=$(CURDIR)

okularPid=${topDir}/okular.pid

pdfFilePath=${topDir}/build/${project}-user-manual
pdfFilePathName=${pdfFilePath}/${project}-user-manual_color_en.pdf 
htmlDirPath=${topDir}/build/${project}-user-manual/html/${project}-user-manual

default: pdf_r

all: pdf html

all_f: pdf_f html_f

all_f_r: pdf_f_r html_f_r

.PHONY: reader
reader:
	okular --geometry 1268x1099-0-34 $(pdfFilePathName) & echo $$! > okular.pid

# Make the pdf file without forcing without reload
pdf:
	daps -d ${topDir}/DC-${project}-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Make the pdf file with forcing remaking all the targets and without reload
pdf_f:
	daps --force -d ${topDir}/DC-${project}-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_r: pdf
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_f_r: pdf_f
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

html:
	daps -d ${topDir}/DC-${project}-user-manual --verbosity=3 html --static

html_f: html
	daps --force -d ${topDir}/DC-${project}-user-manual --verbosity=3 html --static

html_r: html
	firefox-reload-page.sh

html_f_r: html_f
	firefox-reload-page.sh

package_html:
	daps -d ${topDir}/DC-${project}-user-manual package-html

check_dir:
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

	if [ -d "xml" ];\
	 	then \
		echo "Not in a user manual top source directory.";\
		exit 1;\
		fi

=== debian/changelog ===
minexpert2 (7.4.1-1) unstable; urgency=low

  * Fix glitch remaining for times where MzIntegrationParams belonged to this
    project (now in libpappsomspp).

  * Fix warning about casting int(0) to enum member.

  * Fix filenames of the STIX2 fonts used for the user manual. The bug was
    reported by Lucas Nussbaum <lucas@debian.org>. Thanks to Juhani Numminen
    <juhaninumminen0@gmail.com> and Dennis Filder <d.filder@web.de> for
    suggesting fixes (Closes: #982713).

  * Standards-Version: 4.5.1. No changes required.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 20 Feb 2021 12:29:25 +0100

=== debian/control ===
--- 
+++ 
@@ -19,16 +19,16 @@
  libjs-mathjax,
  fonts-mathjax,
  fonts-mathjax-extras,
- texlive-fonts-extra,
+ texlive-fonts-extra (>= 2020.20210202),
  fonts-ebgaramond-extra,
  libqcustomplot-dev(>= 2.0),
- libisospec++-dev (>=2.1.2),
+ libisospec++-dev (>=2.1.3),
  libpappsomspp-dev (>= 0.8.15),
  libpappsomspp-widget-dev (>= 0.8.15),
  docbook-to-man,
  qttools5-dev-tools,
  qtchooser
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: http://www.msxpertsuite.org/
 Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
 Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manual

	cd doc/user-manual && \
		sed -i 's|/home/rusconi/devel/minexpert2/development/doc/user-manual/fop.xconf|$(CURDIR)/doc/user-manual/fop.xconf|' DC-minexpert2-user-manual

override_dh_auto_build:
	cd debian/build && make

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install
